export interface Lift {
    /** Wraps a Number to provide a richer API. Unwrap with .value() **/
    (obj: number): NumberOps;
    /** Wraps a String to provide a richer API. Unwrap with .value() **/
    (obj: string): StringOps;
    /** Wraps a boolean to provide a richer API. Unwrap with .value() **/
    (obj: boolean): BoolOps;
    /** Wraps an Array to provide a richer API. Unwrap with .value() **/
    <T>(obj: T[]): ArrayOps<T>;
    /** Wraps a plain Object to provide a richer API. Unwrap with .value() **/
    <T>(obj: T): ObjectOps<T>;
}
declare const lift: Lift;
export default lift;
export declare class ArrayOps<A> {
    constructor(array: A[]);
    private _isLiftWrapper;
    private _value;
    value(): A[];
}
export declare class ObjectOps<A> {
    constructor(object: A);
    private _isLiftWrapper;
    private _value;
    value(): A;
}
export declare class NumberOps {
    constructor(num: number);
    private _isLiftWrapper;
    private _value;
    value(): number;
}
export declare class StringOps {
    constructor(str: string);
    private _isLiftWrapper;
    private _value;
    value(): string;
}
export declare class BoolOps {
    constructor(value: boolean);
    private _isLiftWrapper;
    private _value;
    value(): boolean;
}
export interface Wrapper<A> {
    value(): A;
}
export declare function getValue<A>(input: A | Wrapper<A>): A;
