import { ObjectOps } from '../';
declare module '../' {
    interface ObjectOps<A> {
        add: typeof add;
    }
}
/**
 * Adds a key/value to this "Map" object.
 * To update an object while preserving its type, use "update()" instead.
 */
export declare function add<K extends string, V>(this: ObjectOps<Record<K, V>>, key: K, value: V): ObjectOps<Record<K, V>>;
