import { Option } from 'option.ts';
import { ObjectOps } from '../';
declare module '../' {
    interface ObjectOps<A> {
        get: typeof get;
    }
}
/**
 * Returns the value found at the provided key, as an Option.
 * Usage 1: read a value from a "Map" object
 * Usage 2: read an optional value from a domain object
 */
export declare function get<A, K extends keyof A>(this: ObjectOps<OptionalMap<A>>, key: K): Option<A[K]>;
export declare type OptionalMap<T> = {
    [P in keyof T]: T[P] | undefined | null;
};
